from collections import defaultdict

from flask import Flask, request

from gpt import respond

app = Flask(__name__)

conversations = defaultdict(lambda: [])


@app.route("/", methods=['GET', 'POST'])
def hello():
    if request.headers.get("Authorization") != "<set-an-api-key-here>":
        return wrap_response("That's not a valid access token")
    # print(request.headers)
    # print(request.data)
    print(request.json)
    req = request.json
    session = get_session(req)
    query = get_query(req)
    language = req['queryResult']['languageCode']
    print(session)
    print(query)

    if req['queryResult']['queryText'] == "GOOGLE_ASSISTANT_WELCOME":
        print("Respond with welcome message")
        return wrap_response("Hva kan jeg hjelpe deg med?" if language == 'no' else "How can I help you?")

    conv = conversations[session]
    if len(conv) > 0:
        print(" -> previously:")
        for line in conv: print("   ", line)

    answer = respond(conv, query, language)

    res = wrap_response(answer)
    print(res)
    conv.append((query, answer))  # Cache the conversation
    return res


def get_session(req):
    return req['originalDetectIntentRequest']['payload']['conversation']['conversationId']


def get_query(req):
    return req['originalDetectIntentRequest']['payload']['inputs'][0]['rawInputs'][0]['query']


def wrap_response(query):
    return {
        "payload": {
            "google": {
                "expectUserResponse": True,
                "richResponse": {
                    "items": [
                        {
                            "simpleResponse": {
                                "textToSpeech": query,
                                "displayText": query
                            }
                        }
                    ]
                }
            }
        }
    }
